import axios from 'axios'
import store from '@/store'
import storage from 'store'
import notification from 'ant-design-vue/es/notification'
import { VueAxios } from './axios'
import { ACCESS_TOKEN } from '@/store/mutation-types'

// 创建 axios 实例
const request = axios.create({
  // API 请求的默认前缀
  baseURL: process.env.VUE_APP_API_BASE_URL,
  timeout: 10000 // 请求超时时间
})

// 异常拦截处理器
const errorHandler = (error) => {
  if (error.response) {
    const data = error.response.data
    // 从 localstorage 获取 token
    const token = storage.get(ACCESS_TOKEN)
    if (error.response.status === 403) {
      notification.error({
        message: 'Forbidden',
        description: data.message
      })
    }

    if (error.response.status === 401 && !(data.result && data.result.isLogin)) {
      notification.error({
        message: 'Unauthorized',
        description: 'Authorization verification failed'
      })
      if (token) {
        store.dispatch('Logout').then(() => {
          setTimeout(() => {
            window.location.reload()
          }, 1500)
        })
      }
    }
  }
  return Promise.reject(error)
}

// request interceptor
request.interceptors.request.use(config => {
  const token = storage.get(ACCESS_TOKEN)
  // 如果 token 存在
  // 让每个请求携带自定义 token 请根据实际情况自行修改
  if (token) {
    config.headers['Authorization'] = token
  }
  config.headers['Accept'] = 'application/json'
  return config
}, errorHandler)

// response interceptor
request.interceptors.response.use((response) => {
  const body = response.data

  if (response.headers.authorization) {
    storage.set(ACCESS_TOKEN, response.headers.authorization, 60 * 60 * 1000)
    store.commit('SET_TOKEN', response.headers.authorization)
  }

  if (body.status_code === 401) {
    // tishixiaoxi
    // notification.error({
    //   message: '警告⚠️警告',
    //   description: '当前登录出现问题~请重新登录'
    // })
    const key = 'updatable'
    notification.error({
      message: '警告⚠️警告⚠️警告⚠️警告⚠️警告',
      description: '当前账户登录过期或者被禁用，请重新登录~',
      btn: h => {
        return h(
          'a-button', {
            props: {
              type: 'danger',
              size: 'small'
            },
            on: {
              click: () => {
                store.dispatch('Logout').then(() => {
                  // setTimeout(() => {
                    window.location.reload()
                  // }, 500)
                })
              }
            }
          },
          '知道了'
        )
      },
      key
    })
  }

  if (body.status_code === 200) {
    return body.data
  }

  return Promise.reject(body)
}, errorHandler)

const installer = {
  vm: {},
  install (Vue) {
    Vue.use(VueAxios, request)
  }
}

export default request

export {
  installer as VueAxios,
  request as axios
}
